Option Strict Off
Option Explicit On

'Imports System.Runtime.InteropServices
Imports System
'Imports System.Text
Imports System.Runtime.InteropServices
'Imports System.Security.Permissions


Module hudio464
    '=============================================
    '  HUSB-DIO464 Driver I/F DLL Function Module
    '      file name:hudio464.vb
    '      date     :2009/12/01
    '      version  :1.0.0.1
    '  Copyright(C) 2007-2009  Hivertec Inc.
    '  All Rights Reserved.
    '=============================================

    ' ߂l
    Public Const NOT_FOUND As Integer = &H1
    Public Const ALREADY_OPENED As Integer = &H2
    Public Const NOT_MEMORY As Integer = &H4
    Public Const INVALID_HANDLE As Integer = &H8
    Public Const NOT_READY As Integer = &H10
    Public Const ILLEGAL_PARAM As Integer = &H100

    ' \
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure HUSBDEVINF
        Dim BrdID As Short  ' {[hID        ( 0`15 )
        Dim EPcnt As Short  ' ߲Đ     (>=2)
        Dim EPspc0 As Short ' Gh|Cgdl   (&H81,&H02,&H00,&H00)
        Dim EPspc1 As Short
        Dim EPspc2 As Short
        Dim EPspc3 As Short
        Dim EPspc4 As Short
        Dim EPspc5 As Short
        Dim EPspc6 As Short
        Dim EPspc7 As Short
        Dim EPsiz0 As Short ' Gh|CgoCg(64,64, 0, 0)
        Dim EPsiz1 As Short
        Dim EPsiz2 As Short
        Dim EPsiz3 As Short
        Dim EPsiz4 As Short
        Dim EPsiz5 As Short
        Dim EPsiz6 As Short
        Dim EPsiz7 As Short
        Dim EPopt0 As Short ' Gh|CgIvV( \ )
        Dim EPopt1 As Short
        Dim EPopt2 As Short
        Dim EPopt3 As Short
        Dim EPopt4 As Short
        Dim EPopt5 As Short
        Dim EPopt6 As Short
        Dim EPopt7 As Short
        Dim EPhdl0 As Integer   ' Gh|Cgnh(pCvnh)
        Dim EPhdl1 As Integer
        Dim EPhdl2 As Integer
        Dim EPhdl3 As Integer
        Dim EPhdl4 As Integer
        Dim EPhdl5 As Integer
        Dim EPhdl6 As Integer
        Dim EPhdl7 As Integer
    End Structure

    '------------------------------------------------------------------------------
    ' DLL֐vg^Cv
    '------------------------------------------------------------------------------
    ' foCX̎擾(FfoCX̌̃AhX)
    Declare Function dio464_GetDeviceCount Lib "hudio464.dll" (ByRef pDevNum As Integer) As Integer

    ' foCX̎擾(FfoCX̌̃AhXCfoCX񃊃Xg̐擪AhX)
    Declare Function dio464_GetDeviceInfo Lib "hudio464.dll" ( _
            ByRef pDevNum As Integer, _
            <Out(), MarshalAs(UnmanagedType.LPArray)> ByVal pHusbDevInfo() As HUSBDEVINF _
    ) As Integer

    ' foCX̃I[v(FHUSBfoCXnh̃AhXCfoCX̃AhX)
    Declare Function dio464_OpenDevice Lib "hudio464.dll" (ByRef hDevID As Integer, ByRef pHusbDevInfo As HUSBDEVINF) As Integer

    ' foCX̃N[Y(FHUSBfoCXnh)
    Declare Function dio464_CloseDevice Lib "hudio464.dll" (ByVal hDevID As Integer) As Integer

    ' ̓|[goCgǍ(FfoCXnhA|[gԍAf[^i[)
    Declare Function dio464_rInB Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByRef wData As Short) As Integer

    ' o̓|[goCgǍ(FfoCXnhA|[gԍAf[^i[)
    Declare Function dio464_rOutB Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByRef wData As Short) As Integer

    ' o̓|[goCg(FfoCXnhA|[gԍAo̓f[^)
    Declare Function dio464_wOutB Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByVal wData As Short) As Integer

    ' ̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
    Declare Function dio464_rInW Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByRef wData As Short) As Integer

    ' o̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
    Declare Function dio464_rOutW Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByRef wData As Short) As Integer

    ' o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
    Declare Function dio464_wOutW Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByVal wData As Short) As Integer

    ' ̓|[gSoCgǍ(FfoCXnhAf[^i[)
    Declare Function dio464_rInDW Lib "hudio464.dll" (ByVal hDevID As Integer, ByRef dwData As Integer) As Integer

    ' o̓|[gSoCgǍ(FfoCXnhAf[^i[)
    Declare Function dio464_rOutDW Lib "hudio464.dll" (ByVal hDevID As Integer, ByRef dwData As Integer) As Integer

    ' o̓|[gSoCg(FfoCXnhAo̓f[^)
    Declare Function dio464_wOutDW Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal dwData As Integer) As Integer

    ' o̓|[gSoCgƓ̓|[gSoCgǍ(FfoCXnhAo̓f[^)
    Declare Function dio464_InOutDW Lib "hudio464.dll" (ByVal hDevID As Integer, ByRef dwRdt As Integer, ByVal dwWdt As Integer) As Integer

    ' tB^[̐ݒ(FfoCXnhA|[gwAtB^[)
    Declare Function dio464_SetFilter Lib "hudio464.dll" (ByVal hDevID As Integer, ByVal wPort As Short, ByVal dwTime As Integer) As Integer
End Module