
using System;
using System.Runtime.InteropServices;

// HUSB-DIO464 Driver I/F DLL Functions
// file name:hudio464.cs
// date     :2009/12/1
// Copyright(C) 2009  Hivertec,inc. All Rights Reserved.

public class Hudio464
{
	// ߂l
	public const uint NOT_FOUND = 1;
	public const uint ALREADY_OPENED = 2;
	public const uint NOT_MEMORY = 4;
	public const uint INVALID_HANDLE = 8;
	public const uint NOT_READY = 0x10;
	public const uint ILLEGAL_PARAM = 0x100;

	// foCX
    [StructLayout(LayoutKind.Sequential)]
    public struct HUSBDEVINF
    {
		public ushort BrdID;	// {[hID        ( 0`15 )
		public ushort EPcnt;	// Gh|Cg     (>=2)
		public ushort EPspc0;	// Gh|Cgdl   (0x81,0x02,0x00,0x00)
		public ushort EPspc1;
		public ushort EPspc2;
		public ushort EPspc3;
		public ushort EPspc4;
		public ushort EPspc5;
		public ushort EPspc6;
		public ushort EPspc7;
		public ushort EPsiz0;	// Gh|CgoCg(32,32, 0, 0)
		public ushort EPsiz1;
		public ushort EPsiz2;
		public ushort EPsiz3;
		public ushort EPsiz4;
		public ushort EPsiz5;
		public ushort EPsiz6;
		public ushort EPsiz7;
		public ushort EPopt0;	// Gh|CgIvV( \ )
		public ushort EPopt1;
		public ushort EPopt2;
		public ushort EPopt3;
		public ushort EPopt4;
		public ushort EPopt5;
		public ushort EPopt6;
		public ushort EPopt7;
        public IntPtr EPhdl0;// Gh|Cgnh(pCvnh)  
        public IntPtr EPhdl1;@
        public IntPtr EPhdl2;
        public IntPtr EPhdl3;
        public IntPtr EPhdl4;
        public IntPtr EPhdl5;
        public IntPtr EPhdl6;
        public IntPtr EPhdl7; 
    }

	// foCX̎擾(FfoCX̌)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_GetDeviceCount(ref uint count);
    
	// foCX̎擾(FfoCX̌AfoCX)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_GetDeviceInfo(ref uint count, [In, Out, MarshalAs(UnmanagedType.LPArray)] HUSBDEVINF[] HusbInf);
    
	// foCXI[v(FfoCXnhAfoCX)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_OpenDevice(ref uint hDev, ref HUSBDEVINF HusbInf);
    
	// foCXN[Y(FfoCXnh)
	[DllImport("Hudio464.dll")]
    public static extern uint dio464_CloseDevice(uint hDev);
    
	// ̓|[gPoCgǍ(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInB(uint hDev, ushort port, ref ushort wrdt);

	// o̓|[gPoCgǍ(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutB(uint hDev, ushort port, ref ushort wrdt);

	// o̓|[gPoCg(FfoCXnhA|[gԍAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutB(uint hDev, ushort port, ushort wwdt);

	// ̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInW(uint hDev, ushort port, ref ushort wwdt);

	// o̓|[gQoCgǍ(FfoCXnhA|[gԍAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutW(uint hDev, ushort port, ref ushort wwdt);

	// o̓|[gQoCg(FfoCXnhA|[gԍAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutW(uint hDev, ushort port, ushort wwdt);

	// ̓|[gSoCgǍ(FfoCXnhAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rInDW(uint hDev, ref uint drdt);

	// o̓|[gSoCgǍ(FfoCXnhAf[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_rOutDW(uint hDev, ref uint drdt);

	// o̓|[gSoCg(FfoCXnhAo̓f[^)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_wOutDW(uint hDev, uint dwdt);

	// o̓|[gSoCgݒO̓̓|[gSoCgǍ
	// (FfoCXnhAo̓f[^Af[^i[)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_InOutDW(uint hDev, ref uint drdt, uint dwdt);

	// w|[g̃tB^ݒ(FfoCXnhA|[gwATvO)
	[DllImport("Hudio464.dll")] 
	public static extern uint dio464_SetFilter(uint hDev, ushort port, ushort wtm);
}
